/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"

#if ENABLE(MEDIA_STREAM)

#include "JSAllAudioCapabilities.h"

#include "AllAudioCapabilities.h"
#include "CapabilityRange.h"
#include "DOMStringList.h"
#include "JSCapabilityRange.h"
#include "JSDOMStringList.h"
#include <runtime/JSArray.h>
#include <wtf/GetPtr.h>

using namespace JSC;

namespace WebCore {

/* Hash table */

static const HashTableValue JSAllAudioCapabilitiesTableValues[] =
{
    { "sourceId", DontDelete | ReadOnly, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsAllAudioCapabilitiesSourceId), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
    { "volume", DontDelete | ReadOnly, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsAllAudioCapabilitiesVolume), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
    { 0, 0, NoIntrinsic, 0, 0 }
};

static const HashTable JSAllAudioCapabilitiesTable = { 4, 3, true, JSAllAudioCapabilitiesTableValues, 0 };
/* Hash table for prototype */

static const HashTableValue JSAllAudioCapabilitiesPrototypeTableValues[] =
{
    { 0, 0, NoIntrinsic, 0, 0 }
};

static const HashTable JSAllAudioCapabilitiesPrototypeTable = { 1, 0, false, JSAllAudioCapabilitiesPrototypeTableValues, 0 };
const ClassInfo JSAllAudioCapabilitiesPrototype::s_info = { "AllAudioCapabilitiesPrototype", &Base::s_info, &JSAllAudioCapabilitiesPrototypeTable, 0, CREATE_METHOD_TABLE(JSAllAudioCapabilitiesPrototype) };

JSObject* JSAllAudioCapabilitiesPrototype::self(VM& vm, JSGlobalObject* globalObject)
{
    return getDOMPrototype<JSAllAudioCapabilities>(vm, globalObject);
}

const ClassInfo JSAllAudioCapabilities::s_info = { "AllAudioCapabilities", &Base::s_info, &JSAllAudioCapabilitiesTable, 0 , CREATE_METHOD_TABLE(JSAllAudioCapabilities) };

JSAllAudioCapabilities::JSAllAudioCapabilities(Structure* structure, JSDOMGlobalObject* globalObject, PassRefPtr<AllAudioCapabilities> impl)
    : JSMediaStreamCapabilities(structure, globalObject, impl)
{
}

void JSAllAudioCapabilities::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    ASSERT(inherits(info()));
}

JSObject* JSAllAudioCapabilities::createPrototype(VM& vm, JSGlobalObject* globalObject)
{
    return JSAllAudioCapabilitiesPrototype::create(vm, globalObject, JSAllAudioCapabilitiesPrototype::createStructure(vm, globalObject, JSMediaStreamCapabilitiesPrototype::self(vm, globalObject)));
}

bool JSAllAudioCapabilities::getOwnPropertySlot(JSObject* object, ExecState* exec, PropertyName propertyName, PropertySlot& slot)
{
    JSAllAudioCapabilities* thisObject = jsCast<JSAllAudioCapabilities*>(object);
    ASSERT_GC_OBJECT_INHERITS(thisObject, info());
    return getStaticValueSlot<JSAllAudioCapabilities, Base>(exec, JSAllAudioCapabilitiesTable, thisObject, propertyName, slot);
}

EncodedJSValue jsAllAudioCapabilitiesSourceId(ExecState* exec, EncodedJSValue slotBase, EncodedJSValue thisValue, PropertyName)
{
    JSAllAudioCapabilities* castedThis = jsDynamicCast<JSAllAudioCapabilities*>(JSValue::decode(thisValue));
    UNUSED_PARAM(slotBase);
    if (!castedThis)
        return throwVMTypeError(exec);
    UNUSED_PARAM(exec);
    AllAudioCapabilities& impl = castedThis->impl();
    JSValue result = jsArray(exec, castedThis->globalObject(), impl.sourceId());
    return JSValue::encode(result);
}


EncodedJSValue jsAllAudioCapabilitiesVolume(ExecState* exec, EncodedJSValue slotBase, EncodedJSValue thisValue, PropertyName)
{
    JSAllAudioCapabilities* castedThis = jsDynamicCast<JSAllAudioCapabilities*>(JSValue::decode(thisValue));
    UNUSED_PARAM(slotBase);
    if (!castedThis)
        return throwVMTypeError(exec);
    UNUSED_PARAM(exec);
    AllAudioCapabilities& impl = castedThis->impl();
    JSValue result = toJS(exec, castedThis->globalObject(), WTF::getPtr(impl.volume()));
    return JSValue::encode(result);
}


#if ENABLE(BINDING_INTEGRITY)
#if PLATFORM(WIN)
#pragma warning(disable: 4483)
extern "C" { extern void (*const __identifier("??_7AllAudioCapabilities@WebCore@@6B@")[])(); }
#else
extern "C" { extern void* _ZTVN7WebCore20AllAudioCapabilitiesE[]; }
#endif
#endif
JSC::JSValue toJS(JSC::ExecState* exec, JSDOMGlobalObject* globalObject, AllAudioCapabilities* impl)
{
    if (!impl)
        return jsNull();
    if (JSValue result = getExistingWrapper<JSAllAudioCapabilities>(exec, impl))
        return result;

#if ENABLE(BINDING_INTEGRITY)
    void* actualVTablePointer = *(reinterpret_cast<void**>(impl));
#if PLATFORM(WIN)
    void* expectedVTablePointer = reinterpret_cast<void*>(__identifier("??_7AllAudioCapabilities@WebCore@@6B@"));
#else
    void* expectedVTablePointer = &_ZTVN7WebCore20AllAudioCapabilitiesE[2];
#if COMPILER(CLANG)
    // If this fails AllAudioCapabilities does not have a vtable, so you need to add the
    // ImplementationLacksVTable attribute to the interface definition
    COMPILE_ASSERT(__is_polymorphic(AllAudioCapabilities), AllAudioCapabilities_is_not_polymorphic);
#endif
#endif
    // If you hit this assertion you either have a use after free bug, or
    // AllAudioCapabilities has subclasses. If AllAudioCapabilities has subclasses that get passed
    // to toJS() we currently require AllAudioCapabilities you to opt out of binding hardening
    // by adding the SkipVTableValidation attribute to the interface IDL definition
    RELEASE_ASSERT(actualVTablePointer == expectedVTablePointer);
#endif
    ReportMemoryCost<AllAudioCapabilities>::reportMemoryCost(exec, impl);
    return createNewWrapper<JSAllAudioCapabilities>(exec, globalObject, impl);
}


}

#endif // ENABLE(MEDIA_STREAM)
