/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"

#if ENABLE(FONT_LOAD_EVENTS)

#include "JSCSSFontFaceLoadEvent.h"

#include "CSSFontFaceLoadEvent.h"
#include "CSSFontFaceRule.h"
#include "DOMError.h"
#include "JSCSSFontFaceRule.h"
#include "JSDOMError.h"
#include <wtf/GetPtr.h>

using namespace JSC;

namespace WebCore {

/* Hash table */

static const HashTableValue JSCSSFontFaceLoadEventTableValues[] =
{
    { "fontface", DontDelete | ReadOnly, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSFontFaceLoadEventFontface), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
    { "error", DontDelete | ReadOnly, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCSSFontFaceLoadEventError), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
    { 0, 0, NoIntrinsic, 0, 0 }
};

static const HashTable JSCSSFontFaceLoadEventTable = { 4, 3, true, JSCSSFontFaceLoadEventTableValues, 0 };
/* Hash table for prototype */

static const HashTableValue JSCSSFontFaceLoadEventPrototypeTableValues[] =
{
    { 0, 0, NoIntrinsic, 0, 0 }
};

static const HashTable JSCSSFontFaceLoadEventPrototypeTable = { 1, 0, false, JSCSSFontFaceLoadEventPrototypeTableValues, 0 };
static const HashTable& getJSCSSFontFaceLoadEventPrototypeTable(VM& vm)
{
    return getHashTableForGlobalData(vm, JSCSSFontFaceLoadEventPrototypeTable);
}

const ClassInfo JSCSSFontFaceLoadEventPrototype::s_info = { "CSSFontFaceLoadEventPrototype", &Base::s_info, 0, getJSCSSFontFaceLoadEventPrototypeTable, CREATE_METHOD_TABLE(JSCSSFontFaceLoadEventPrototype) };

JSObject* JSCSSFontFaceLoadEventPrototype::self(VM& vm, JSGlobalObject* globalObject)
{
    return getDOMPrototype<JSCSSFontFaceLoadEvent>(vm, globalObject);
}

static const HashTable& getJSCSSFontFaceLoadEventTable(VM& vm)
{
    return getHashTableForGlobalData(vm, JSCSSFontFaceLoadEventTable);
}

const ClassInfo JSCSSFontFaceLoadEvent::s_info = { "CSSFontFaceLoadEvent", &Base::s_info, 0, getJSCSSFontFaceLoadEventTable , CREATE_METHOD_TABLE(JSCSSFontFaceLoadEvent) };

JSCSSFontFaceLoadEvent::JSCSSFontFaceLoadEvent(Structure* structure, JSDOMGlobalObject* globalObject, PassRefPtr<CSSFontFaceLoadEvent> impl)
    : JSEvent(structure, globalObject, impl)
{
}

void JSCSSFontFaceLoadEvent::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    ASSERT(inherits(info()));
}

JSObject* JSCSSFontFaceLoadEvent::createPrototype(VM& vm, JSGlobalObject* globalObject)
{
    return JSCSSFontFaceLoadEventPrototype::create(vm, globalObject, JSCSSFontFaceLoadEventPrototype::createStructure(vm, globalObject, JSEventPrototype::self(vm, globalObject)));
}

bool JSCSSFontFaceLoadEvent::getOwnPropertySlot(JSObject* object, ExecState* exec, PropertyName propertyName, PropertySlot& slot)
{
    JSCSSFontFaceLoadEvent* thisObject = jsCast<JSCSSFontFaceLoadEvent*>(object);
    ASSERT_GC_OBJECT_INHERITS(thisObject, info());
    return getStaticValueSlot<JSCSSFontFaceLoadEvent, Base>(exec, getJSCSSFontFaceLoadEventTable(exec->vm()), thisObject, propertyName, slot);
}

EncodedJSValue jsCSSFontFaceLoadEventFontface(ExecState* exec, EncodedJSValue slotBase, EncodedJSValue thisValue, PropertyName)
{
    JSCSSFontFaceLoadEvent* castedThis = jsDynamicCast<JSCSSFontFaceLoadEvent*>(JSValue::decode(thisValue));
    UNUSED_PARAM(slotBase);
    if (!castedThis)
        return throwVMTypeError(exec);
    UNUSED_PARAM(exec);
    CSSFontFaceLoadEvent& impl = castedThis->impl();
    JSValue result = toJS(exec, castedThis->globalObject(), WTF::getPtr(impl.fontface()));
    return JSValue::encode(result);
}


EncodedJSValue jsCSSFontFaceLoadEventError(ExecState* exec, EncodedJSValue slotBase, EncodedJSValue thisValue, PropertyName)
{
    JSCSSFontFaceLoadEvent* castedThis = jsDynamicCast<JSCSSFontFaceLoadEvent*>(JSValue::decode(thisValue));
    UNUSED_PARAM(slotBase);
    if (!castedThis)
        return throwVMTypeError(exec);
    UNUSED_PARAM(exec);
    CSSFontFaceLoadEvent& impl = castedThis->impl();
    JSValue result = toJS(exec, castedThis->globalObject(), WTF::getPtr(impl.error()));
    return JSValue::encode(result);
}



}

#endif // ENABLE(FONT_LOAD_EVENTS)
