/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"

#if ENABLE(CSP_NEXT)

#include "JSDOMSecurityPolicy.h"

#include "DOMSecurityPolicy.h"
#include "DOMStringList.h"
#include "ExceptionCode.h"
#include "JSDOMBinding.h"
#include "JSDOMStringList.h"
#include <runtime/Error.h>
#include <wtf/GetPtr.h>

using namespace JSC;

namespace WebCore {

/* Hash table */

static const HashTableValue JSDOMSecurityPolicyTableValues[] =
{
    { "allowsEval", DontDelete | ReadOnly, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsDOMSecurityPolicyAllowsEval), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
    { "allowsInlineScript", DontDelete | ReadOnly, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsDOMSecurityPolicyAllowsInlineScript), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
    { "allowsInlineStyle", DontDelete | ReadOnly, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsDOMSecurityPolicyAllowsInlineStyle), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
    { "isActive", DontDelete | ReadOnly, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsDOMSecurityPolicyIsActive), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
    { "reportURIs", DontDelete | ReadOnly, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsDOMSecurityPolicyReportURIs), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
    { "constructor", DontEnum | ReadOnly, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsDOMSecurityPolicyConstructor), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
    { 0, 0, NoIntrinsic, 0, 0 }
};

static const HashTable JSDOMSecurityPolicyTable = { 17, 15, true, JSDOMSecurityPolicyTableValues, 0 };
/* Hash table for constructor */

static const HashTableValue JSDOMSecurityPolicyConstructorTableValues[] =
{
    { 0, 0, NoIntrinsic, 0, 0 }
};

static const HashTable JSDOMSecurityPolicyConstructorTable = { 1, 0, false, JSDOMSecurityPolicyConstructorTableValues, 0 };
const ClassInfo JSDOMSecurityPolicyConstructor::s_info = { "SecurityPolicyConstructor", &Base::s_info, &JSDOMSecurityPolicyConstructorTable, 0, CREATE_METHOD_TABLE(JSDOMSecurityPolicyConstructor) };

JSDOMSecurityPolicyConstructor::JSDOMSecurityPolicyConstructor(Structure* structure, JSDOMGlobalObject* globalObject)
    : DOMConstructorObject(structure, globalObject)
{
}

void JSDOMSecurityPolicyConstructor::finishCreation(VM& vm, JSDOMGlobalObject* globalObject)
{
    Base::finishCreation(vm);
    ASSERT(inherits(info()));
    putDirect(vm, vm.propertyNames->prototype, JSDOMSecurityPolicyPrototype::self(vm, globalObject), DontDelete | ReadOnly);
    putDirect(vm, vm.propertyNames->length, jsNumber(0), ReadOnly | DontDelete | DontEnum);
}

bool JSDOMSecurityPolicyConstructor::getOwnPropertySlot(JSObject* object, ExecState* exec, PropertyName propertyName, PropertySlot& slot)
{
    return getStaticValueSlot<JSDOMSecurityPolicyConstructor, JSDOMWrapper>(exec, JSDOMSecurityPolicyConstructorTable, jsCast<JSDOMSecurityPolicyConstructor*>(object), propertyName, slot);
}

/* Hash table for prototype */

static const HashTableValue JSDOMSecurityPolicyPrototypeTableValues[] =
{
    { "allowsConnectionTo", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsDOMSecurityPolicyPrototypeFunctionAllowsConnectionTo), (intptr_t) (1) },
    { "allowsFontFrom", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsDOMSecurityPolicyPrototypeFunctionAllowsFontFrom), (intptr_t) (1) },
    { "allowsFormAction", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsDOMSecurityPolicyPrototypeFunctionAllowsFormAction), (intptr_t) (1) },
    { "allowsFrameFrom", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsDOMSecurityPolicyPrototypeFunctionAllowsFrameFrom), (intptr_t) (1) },
    { "allowsImageFrom", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsDOMSecurityPolicyPrototypeFunctionAllowsImageFrom), (intptr_t) (1) },
    { "allowsMediaFrom", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsDOMSecurityPolicyPrototypeFunctionAllowsMediaFrom), (intptr_t) (1) },
    { "allowsObjectFrom", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsDOMSecurityPolicyPrototypeFunctionAllowsObjectFrom), (intptr_t) (1) },
    { "allowsPluginType", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsDOMSecurityPolicyPrototypeFunctionAllowsPluginType), (intptr_t) (1) },
    { "allowsScriptFrom", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsDOMSecurityPolicyPrototypeFunctionAllowsScriptFrom), (intptr_t) (1) },
    { "allowsStyleFrom", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsDOMSecurityPolicyPrototypeFunctionAllowsStyleFrom), (intptr_t) (1) },
    { 0, 0, NoIntrinsic, 0, 0 }
};

static const HashTable JSDOMSecurityPolicyPrototypeTable = { 33, 31, false, JSDOMSecurityPolicyPrototypeTableValues, 0 };
const ClassInfo JSDOMSecurityPolicyPrototype::s_info = { "SecurityPolicyPrototype", &Base::s_info, &JSDOMSecurityPolicyPrototypeTable, 0, CREATE_METHOD_TABLE(JSDOMSecurityPolicyPrototype) };

JSObject* JSDOMSecurityPolicyPrototype::self(VM& vm, JSGlobalObject* globalObject)
{
    return getDOMPrototype<JSDOMSecurityPolicy>(vm, globalObject);
}

bool JSDOMSecurityPolicyPrototype::getOwnPropertySlot(JSObject* object, ExecState* exec, PropertyName propertyName, PropertySlot& slot)
{
    JSDOMSecurityPolicyPrototype* thisObject = jsCast<JSDOMSecurityPolicyPrototype*>(object);
    return getStaticFunctionSlot<JSObject>(exec, JSDOMSecurityPolicyPrototypeTable, thisObject, propertyName, slot);
}

const ClassInfo JSDOMSecurityPolicy::s_info = { "SecurityPolicy", &Base::s_info, &JSDOMSecurityPolicyTable, 0 , CREATE_METHOD_TABLE(JSDOMSecurityPolicy) };

JSDOMSecurityPolicy::JSDOMSecurityPolicy(Structure* structure, JSDOMGlobalObject* globalObject, PassRefPtr<DOMSecurityPolicy> impl)
    : JSDOMWrapper(structure, globalObject)
    , m_impl(impl.leakRef())
{
}

void JSDOMSecurityPolicy::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    ASSERT(inherits(info()));
}

JSObject* JSDOMSecurityPolicy::createPrototype(VM& vm, JSGlobalObject* globalObject)
{
    return JSDOMSecurityPolicyPrototype::create(vm, globalObject, JSDOMSecurityPolicyPrototype::createStructure(vm, globalObject, globalObject->objectPrototype()));
}

void JSDOMSecurityPolicy::destroy(JSC::JSCell* cell)
{
    JSDOMSecurityPolicy* thisObject = static_cast<JSDOMSecurityPolicy*>(cell);
    thisObject->JSDOMSecurityPolicy::~JSDOMSecurityPolicy();
}

JSDOMSecurityPolicy::~JSDOMSecurityPolicy()
{
    releaseImplIfNotNull();
}

bool JSDOMSecurityPolicy::getOwnPropertySlot(JSObject* object, ExecState* exec, PropertyName propertyName, PropertySlot& slot)
{
    JSDOMSecurityPolicy* thisObject = jsCast<JSDOMSecurityPolicy*>(object);
    ASSERT_GC_OBJECT_INHERITS(thisObject, info());
    return getStaticValueSlot<JSDOMSecurityPolicy, Base>(exec, JSDOMSecurityPolicyTable, thisObject, propertyName, slot);
}

EncodedJSValue jsDOMSecurityPolicyAllowsEval(ExecState* exec, EncodedJSValue slotBase, EncodedJSValue thisValue, PropertyName)
{
    JSDOMSecurityPolicy* castedThis = jsDynamicCast<JSDOMSecurityPolicy*>(JSValue::decode(thisValue));
    UNUSED_PARAM(slotBase);
    if (!castedThis)
        return throwVMTypeError(exec);
    UNUSED_PARAM(exec);
    DOMSecurityPolicy& impl = castedThis->impl();
    JSValue result = jsBoolean(impl.allowsEval());
    return JSValue::encode(result);
}


EncodedJSValue jsDOMSecurityPolicyAllowsInlineScript(ExecState* exec, EncodedJSValue slotBase, EncodedJSValue thisValue, PropertyName)
{
    JSDOMSecurityPolicy* castedThis = jsDynamicCast<JSDOMSecurityPolicy*>(JSValue::decode(thisValue));
    UNUSED_PARAM(slotBase);
    if (!castedThis)
        return throwVMTypeError(exec);
    UNUSED_PARAM(exec);
    DOMSecurityPolicy& impl = castedThis->impl();
    JSValue result = jsBoolean(impl.allowsInlineScript());
    return JSValue::encode(result);
}


EncodedJSValue jsDOMSecurityPolicyAllowsInlineStyle(ExecState* exec, EncodedJSValue slotBase, EncodedJSValue thisValue, PropertyName)
{
    JSDOMSecurityPolicy* castedThis = jsDynamicCast<JSDOMSecurityPolicy*>(JSValue::decode(thisValue));
    UNUSED_PARAM(slotBase);
    if (!castedThis)
        return throwVMTypeError(exec);
    UNUSED_PARAM(exec);
    DOMSecurityPolicy& impl = castedThis->impl();
    JSValue result = jsBoolean(impl.allowsInlineStyle());
    return JSValue::encode(result);
}


EncodedJSValue jsDOMSecurityPolicyIsActive(ExecState* exec, EncodedJSValue slotBase, EncodedJSValue thisValue, PropertyName)
{
    JSDOMSecurityPolicy* castedThis = jsDynamicCast<JSDOMSecurityPolicy*>(JSValue::decode(thisValue));
    UNUSED_PARAM(slotBase);
    if (!castedThis)
        return throwVMTypeError(exec);
    UNUSED_PARAM(exec);
    DOMSecurityPolicy& impl = castedThis->impl();
    JSValue result = jsBoolean(impl.isActive());
    return JSValue::encode(result);
}


EncodedJSValue jsDOMSecurityPolicyReportURIs(ExecState* exec, EncodedJSValue slotBase, EncodedJSValue thisValue, PropertyName)
{
    JSDOMSecurityPolicy* castedThis = jsDynamicCast<JSDOMSecurityPolicy*>(JSValue::decode(thisValue));
    UNUSED_PARAM(slotBase);
    if (!castedThis)
        return throwVMTypeError(exec);
    UNUSED_PARAM(exec);
    DOMSecurityPolicy& impl = castedThis->impl();
    JSValue result = toJS(exec, castedThis->globalObject(), WTF::getPtr(impl.reportURIs()));
    return JSValue::encode(result);
}


EncodedJSValue jsDOMSecurityPolicyConstructor(ExecState* exec, EncodedJSValue thisValue, EncodedJSValue, PropertyName)
{
    JSDOMSecurityPolicy* domObject = jsDynamicCast<JSDOMSecurityPolicy*>(JSValue::decode(thisValue));
    if (!domObject)
        return throwVMTypeError(exec);
    if (!domObject)
        return throwVMTypeError(exec);
    return JSValue::encode(JSDOMSecurityPolicy::getConstructor(exec->vm(), domObject->globalObject()));
}

JSValue JSDOMSecurityPolicy::getConstructor(VM& vm, JSGlobalObject* globalObject)
{
    return getDOMConstructor<JSDOMSecurityPolicyConstructor>(vm, jsCast<JSDOMGlobalObject*>(globalObject));
}

EncodedJSValue JSC_HOST_CALL jsDOMSecurityPolicyPrototypeFunctionAllowsConnectionTo(ExecState* exec)
{
    JSValue thisValue = exec->hostThisValue();
    JSDOMSecurityPolicy* castedThis = jsDynamicCast<JSDOMSecurityPolicy*>(thisValue);
    if (!castedThis)
        return throwVMTypeError(exec);
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSDOMSecurityPolicy::info());
    DOMSecurityPolicy& impl = castedThis->impl();
    if (exec->argumentCount() < 1)
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    const String& url(exec->argument(0).isEmpty() ? String() : exec->argument(0).toString(exec)->value(exec));
    if (exec->hadException())
        return JSValue::encode(jsUndefined());

    JSC::JSValue result = jsBoolean(impl.allowsConnectionTo(url));
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsDOMSecurityPolicyPrototypeFunctionAllowsFontFrom(ExecState* exec)
{
    JSValue thisValue = exec->hostThisValue();
    JSDOMSecurityPolicy* castedThis = jsDynamicCast<JSDOMSecurityPolicy*>(thisValue);
    if (!castedThis)
        return throwVMTypeError(exec);
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSDOMSecurityPolicy::info());
    DOMSecurityPolicy& impl = castedThis->impl();
    if (exec->argumentCount() < 1)
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    const String& url(exec->argument(0).isEmpty() ? String() : exec->argument(0).toString(exec)->value(exec));
    if (exec->hadException())
        return JSValue::encode(jsUndefined());

    JSC::JSValue result = jsBoolean(impl.allowsFontFrom(url));
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsDOMSecurityPolicyPrototypeFunctionAllowsFormAction(ExecState* exec)
{
    JSValue thisValue = exec->hostThisValue();
    JSDOMSecurityPolicy* castedThis = jsDynamicCast<JSDOMSecurityPolicy*>(thisValue);
    if (!castedThis)
        return throwVMTypeError(exec);
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSDOMSecurityPolicy::info());
    DOMSecurityPolicy& impl = castedThis->impl();
    if (exec->argumentCount() < 1)
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    const String& url(exec->argument(0).isEmpty() ? String() : exec->argument(0).toString(exec)->value(exec));
    if (exec->hadException())
        return JSValue::encode(jsUndefined());

    JSC::JSValue result = jsBoolean(impl.allowsFormAction(url));
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsDOMSecurityPolicyPrototypeFunctionAllowsFrameFrom(ExecState* exec)
{
    JSValue thisValue = exec->hostThisValue();
    JSDOMSecurityPolicy* castedThis = jsDynamicCast<JSDOMSecurityPolicy*>(thisValue);
    if (!castedThis)
        return throwVMTypeError(exec);
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSDOMSecurityPolicy::info());
    DOMSecurityPolicy& impl = castedThis->impl();
    if (exec->argumentCount() < 1)
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    const String& url(exec->argument(0).isEmpty() ? String() : exec->argument(0).toString(exec)->value(exec));
    if (exec->hadException())
        return JSValue::encode(jsUndefined());

    JSC::JSValue result = jsBoolean(impl.allowsFrameFrom(url));
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsDOMSecurityPolicyPrototypeFunctionAllowsImageFrom(ExecState* exec)
{
    JSValue thisValue = exec->hostThisValue();
    JSDOMSecurityPolicy* castedThis = jsDynamicCast<JSDOMSecurityPolicy*>(thisValue);
    if (!castedThis)
        return throwVMTypeError(exec);
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSDOMSecurityPolicy::info());
    DOMSecurityPolicy& impl = castedThis->impl();
    if (exec->argumentCount() < 1)
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    const String& url(exec->argument(0).isEmpty() ? String() : exec->argument(0).toString(exec)->value(exec));
    if (exec->hadException())
        return JSValue::encode(jsUndefined());

    JSC::JSValue result = jsBoolean(impl.allowsImageFrom(url));
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsDOMSecurityPolicyPrototypeFunctionAllowsMediaFrom(ExecState* exec)
{
    JSValue thisValue = exec->hostThisValue();
    JSDOMSecurityPolicy* castedThis = jsDynamicCast<JSDOMSecurityPolicy*>(thisValue);
    if (!castedThis)
        return throwVMTypeError(exec);
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSDOMSecurityPolicy::info());
    DOMSecurityPolicy& impl = castedThis->impl();
    if (exec->argumentCount() < 1)
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    const String& url(exec->argument(0).isEmpty() ? String() : exec->argument(0).toString(exec)->value(exec));
    if (exec->hadException())
        return JSValue::encode(jsUndefined());

    JSC::JSValue result = jsBoolean(impl.allowsMediaFrom(url));
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsDOMSecurityPolicyPrototypeFunctionAllowsObjectFrom(ExecState* exec)
{
    JSValue thisValue = exec->hostThisValue();
    JSDOMSecurityPolicy* castedThis = jsDynamicCast<JSDOMSecurityPolicy*>(thisValue);
    if (!castedThis)
        return throwVMTypeError(exec);
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSDOMSecurityPolicy::info());
    DOMSecurityPolicy& impl = castedThis->impl();
    if (exec->argumentCount() < 1)
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    const String& url(exec->argument(0).isEmpty() ? String() : exec->argument(0).toString(exec)->value(exec));
    if (exec->hadException())
        return JSValue::encode(jsUndefined());

    JSC::JSValue result = jsBoolean(impl.allowsObjectFrom(url));
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsDOMSecurityPolicyPrototypeFunctionAllowsPluginType(ExecState* exec)
{
    JSValue thisValue = exec->hostThisValue();
    JSDOMSecurityPolicy* castedThis = jsDynamicCast<JSDOMSecurityPolicy*>(thisValue);
    if (!castedThis)
        return throwVMTypeError(exec);
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSDOMSecurityPolicy::info());
    DOMSecurityPolicy& impl = castedThis->impl();
    if (exec->argumentCount() < 1)
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    const String& type(exec->argument(0).isEmpty() ? String() : exec->argument(0).toString(exec)->value(exec));
    if (exec->hadException())
        return JSValue::encode(jsUndefined());

    JSC::JSValue result = jsBoolean(impl.allowsPluginType(type));
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsDOMSecurityPolicyPrototypeFunctionAllowsScriptFrom(ExecState* exec)
{
    JSValue thisValue = exec->hostThisValue();
    JSDOMSecurityPolicy* castedThis = jsDynamicCast<JSDOMSecurityPolicy*>(thisValue);
    if (!castedThis)
        return throwVMTypeError(exec);
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSDOMSecurityPolicy::info());
    DOMSecurityPolicy& impl = castedThis->impl();
    if (exec->argumentCount() < 1)
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    const String& url(exec->argument(0).isEmpty() ? String() : exec->argument(0).toString(exec)->value(exec));
    if (exec->hadException())
        return JSValue::encode(jsUndefined());

    JSC::JSValue result = jsBoolean(impl.allowsScriptFrom(url));
    return JSValue::encode(result);
}

EncodedJSValue JSC_HOST_CALL jsDOMSecurityPolicyPrototypeFunctionAllowsStyleFrom(ExecState* exec)
{
    JSValue thisValue = exec->hostThisValue();
    JSDOMSecurityPolicy* castedThis = jsDynamicCast<JSDOMSecurityPolicy*>(thisValue);
    if (!castedThis)
        return throwVMTypeError(exec);
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSDOMSecurityPolicy::info());
    DOMSecurityPolicy& impl = castedThis->impl();
    if (exec->argumentCount() < 1)
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    const String& url(exec->argument(0).isEmpty() ? String() : exec->argument(0).toString(exec)->value(exec));
    if (exec->hadException())
        return JSValue::encode(jsUndefined());

    JSC::JSValue result = jsBoolean(impl.allowsStyleFrom(url));
    return JSValue::encode(result);
}

bool JSDOMSecurityPolicyOwner::isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown> handle, void*, SlotVisitor& visitor)
{
    UNUSED_PARAM(handle);
    UNUSED_PARAM(visitor);
    return false;
}

void JSDOMSecurityPolicyOwner::finalize(JSC::Handle<JSC::Unknown> handle, void* context)
{
    JSDOMSecurityPolicy* jsDOMSecurityPolicy = jsCast<JSDOMSecurityPolicy*>(handle.get().asCell());
    DOMWrapperWorld& world = *static_cast<DOMWrapperWorld*>(context);
    uncacheWrapper(world, &jsDOMSecurityPolicy->impl(), jsDOMSecurityPolicy);
    jsDOMSecurityPolicy->releaseImpl();
}

#if ENABLE(BINDING_INTEGRITY)
#if PLATFORM(WIN)
#pragma warning(disable: 4483)
extern "C" { extern void (*const __identifier("??_7DOMSecurityPolicy@WebCore@@6B@")[])(); }
#else
extern "C" { extern void* _ZTVN7WebCore17DOMSecurityPolicyE[]; }
#endif
#endif
JSC::JSValue toJS(JSC::ExecState* exec, JSDOMGlobalObject* globalObject, DOMSecurityPolicy* impl)
{
    if (!impl)
        return jsNull();
    if (JSValue result = getExistingWrapper<JSDOMSecurityPolicy>(exec, impl))
        return result;

#if ENABLE(BINDING_INTEGRITY)
    void* actualVTablePointer = *(reinterpret_cast<void**>(impl));
#if PLATFORM(WIN)
    void* expectedVTablePointer = reinterpret_cast<void*>(__identifier("??_7DOMSecurityPolicy@WebCore@@6B@"));
#else
    void* expectedVTablePointer = &_ZTVN7WebCore17DOMSecurityPolicyE[2];
#if COMPILER(CLANG)
    // If this fails DOMSecurityPolicy does not have a vtable, so you need to add the
    // ImplementationLacksVTable attribute to the interface definition
    COMPILE_ASSERT(__is_polymorphic(DOMSecurityPolicy), DOMSecurityPolicy_is_not_polymorphic);
#endif
#endif
    // If you hit this assertion you either have a use after free bug, or
    // DOMSecurityPolicy has subclasses. If DOMSecurityPolicy has subclasses that get passed
    // to toJS() we currently require DOMSecurityPolicy you to opt out of binding hardening
    // by adding the SkipVTableValidation attribute to the interface IDL definition
    RELEASE_ASSERT(actualVTablePointer == expectedVTablePointer);
#endif
    ReportMemoryCost<DOMSecurityPolicy>::reportMemoryCost(exec, impl);
    return createNewWrapper<JSDOMSecurityPolicy>(exec, globalObject, impl);
}

DOMSecurityPolicy* toDOMSecurityPolicy(JSC::JSValue value)
{
    return value.inherits(JSDOMSecurityPolicy::info()) ? &jsCast<JSDOMSecurityPolicy*>(value)->impl() : 0;
}

}

#endif // ENABLE(CSP_NEXT)
