/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"

#if ENABLE(MEDIA_STREAM)

#include "JSMediaTrackConstraint.h"

#include "MediaTrackConstraint.h"
#include <wtf/GetPtr.h>

using namespace JSC;

namespace WebCore {

/* Hash table for prototype */

static const HashTableValue JSMediaTrackConstraintPrototypeTableValues[] =
{
    { 0, 0, NoIntrinsic, 0, 0 }
};

static const HashTable JSMediaTrackConstraintPrototypeTable = { 1, 0, false, JSMediaTrackConstraintPrototypeTableValues, 0 };
const ClassInfo JSMediaTrackConstraintPrototype::s_info = { "MediaTrackConstraintPrototype", &Base::s_info, &JSMediaTrackConstraintPrototypeTable, 0, CREATE_METHOD_TABLE(JSMediaTrackConstraintPrototype) };

JSObject* JSMediaTrackConstraintPrototype::self(VM& vm, JSGlobalObject* globalObject)
{
    return getDOMPrototype<JSMediaTrackConstraint>(vm, globalObject);
}

const ClassInfo JSMediaTrackConstraint::s_info = { "MediaTrackConstraint", &Base::s_info, 0, 0 , CREATE_METHOD_TABLE(JSMediaTrackConstraint) };

JSMediaTrackConstraint::JSMediaTrackConstraint(Structure* structure, JSDOMGlobalObject* globalObject, PassRefPtr<MediaTrackConstraint> impl)
    : JSDOMWrapper(structure, globalObject)
    , m_impl(impl.leakRef())
{
}

void JSMediaTrackConstraint::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    ASSERT(inherits(info()));
}

JSObject* JSMediaTrackConstraint::createPrototype(VM& vm, JSGlobalObject* globalObject)
{
    return JSMediaTrackConstraintPrototype::create(vm, globalObject, JSMediaTrackConstraintPrototype::createStructure(vm, globalObject, globalObject->objectPrototype()));
}

void JSMediaTrackConstraint::destroy(JSC::JSCell* cell)
{
    JSMediaTrackConstraint* thisObject = static_cast<JSMediaTrackConstraint*>(cell);
    thisObject->JSMediaTrackConstraint::~JSMediaTrackConstraint();
}

JSMediaTrackConstraint::~JSMediaTrackConstraint()
{
    releaseImplIfNotNull();
}

bool JSMediaTrackConstraintOwner::isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown> handle, void*, SlotVisitor& visitor)
{
    UNUSED_PARAM(handle);
    UNUSED_PARAM(visitor);
    return false;
}

void JSMediaTrackConstraintOwner::finalize(JSC::Handle<JSC::Unknown> handle, void* context)
{
    JSMediaTrackConstraint* jsMediaTrackConstraint = jsCast<JSMediaTrackConstraint*>(handle.get().asCell());
    DOMWrapperWorld& world = *static_cast<DOMWrapperWorld*>(context);
    uncacheWrapper(world, &jsMediaTrackConstraint->impl(), jsMediaTrackConstraint);
    jsMediaTrackConstraint->releaseImpl();
}

#if ENABLE(BINDING_INTEGRITY)
#if PLATFORM(WIN)
#pragma warning(disable: 4483)
extern "C" { extern void (*const __identifier("??_7MediaTrackConstraint@WebCore@@6B@")[])(); }
#else
extern "C" { extern void* _ZTVN7WebCore20MediaTrackConstraintE[]; }
#endif
#endif
JSC::JSValue toJS(JSC::ExecState* exec, JSDOMGlobalObject* globalObject, MediaTrackConstraint* impl)
{
    if (!impl)
        return jsNull();
    if (JSValue result = getExistingWrapper<JSMediaTrackConstraint>(exec, impl))
        return result;

#if ENABLE(BINDING_INTEGRITY)
    void* actualVTablePointer = *(reinterpret_cast<void**>(impl));
#if PLATFORM(WIN)
    void* expectedVTablePointer = reinterpret_cast<void*>(__identifier("??_7MediaTrackConstraint@WebCore@@6B@"));
#else
    void* expectedVTablePointer = &_ZTVN7WebCore20MediaTrackConstraintE[2];
#if COMPILER(CLANG)
    // If this fails MediaTrackConstraint does not have a vtable, so you need to add the
    // ImplementationLacksVTable attribute to the interface definition
    COMPILE_ASSERT(__is_polymorphic(MediaTrackConstraint), MediaTrackConstraint_is_not_polymorphic);
#endif
#endif
    // If you hit this assertion you either have a use after free bug, or
    // MediaTrackConstraint has subclasses. If MediaTrackConstraint has subclasses that get passed
    // to toJS() we currently require MediaTrackConstraint you to opt out of binding hardening
    // by adding the SkipVTableValidation attribute to the interface IDL definition
    RELEASE_ASSERT(actualVTablePointer == expectedVTablePointer);
#endif
    ReportMemoryCost<MediaTrackConstraint>::reportMemoryCost(exec, impl);
    return createNewWrapper<JSMediaTrackConstraint>(exec, globalObject, impl);
}

MediaTrackConstraint* toMediaTrackConstraint(JSC::JSValue value)
{
    return value.inherits(JSMediaTrackConstraint::info()) ? &jsCast<JSMediaTrackConstraint*>(value)->impl() : 0;
}

}

#endif // ENABLE(MEDIA_STREAM)
