/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"

#if ENABLE(MEDIA_STREAM)

#include "JSMediaTrackConstraints.h"

#include "JSMediaTrackConstraint.h"
#include "JSMediaTrackConstraintSet.h"
#include "MediaTrackConstraint.h"
#include "MediaTrackConstraintSet.h"
#include "MediaTrackConstraints.h"
#include <runtime/JSArray.h>
#include <wtf/GetPtr.h>

using namespace JSC;

namespace WebCore {

/* Hash table */

static const HashTableValue JSMediaTrackConstraintsTableValues[] =
{
    { "mandatory", DontDelete | ReadOnly, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMediaTrackConstraintsMandatory), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
    { "optional", DontDelete | ReadOnly, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMediaTrackConstraintsOptional), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
    { 0, 0, NoIntrinsic, 0, 0 }
};

static const HashTable JSMediaTrackConstraintsTable = { 4, 3, true, JSMediaTrackConstraintsTableValues, 0 };
/* Hash table for prototype */

static const HashTableValue JSMediaTrackConstraintsPrototypeTableValues[] =
{
    { 0, 0, NoIntrinsic, 0, 0 }
};

static const HashTable JSMediaTrackConstraintsPrototypeTable = { 1, 0, false, JSMediaTrackConstraintsPrototypeTableValues, 0 };
const ClassInfo JSMediaTrackConstraintsPrototype::s_info = { "MediaTrackConstraintsPrototype", &Base::s_info, &JSMediaTrackConstraintsPrototypeTable, 0, CREATE_METHOD_TABLE(JSMediaTrackConstraintsPrototype) };

JSObject* JSMediaTrackConstraintsPrototype::self(VM& vm, JSGlobalObject* globalObject)
{
    return getDOMPrototype<JSMediaTrackConstraints>(vm, globalObject);
}

const ClassInfo JSMediaTrackConstraints::s_info = { "MediaTrackConstraints", &Base::s_info, &JSMediaTrackConstraintsTable, 0 , CREATE_METHOD_TABLE(JSMediaTrackConstraints) };

JSMediaTrackConstraints::JSMediaTrackConstraints(Structure* structure, JSDOMGlobalObject* globalObject, PassRefPtr<MediaTrackConstraints> impl)
    : JSDOMWrapper(structure, globalObject)
    , m_impl(impl.leakRef())
{
}

void JSMediaTrackConstraints::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    ASSERT(inherits(info()));
}

JSObject* JSMediaTrackConstraints::createPrototype(VM& vm, JSGlobalObject* globalObject)
{
    return JSMediaTrackConstraintsPrototype::create(vm, globalObject, JSMediaTrackConstraintsPrototype::createStructure(vm, globalObject, globalObject->objectPrototype()));
}

void JSMediaTrackConstraints::destroy(JSC::JSCell* cell)
{
    JSMediaTrackConstraints* thisObject = static_cast<JSMediaTrackConstraints*>(cell);
    thisObject->JSMediaTrackConstraints::~JSMediaTrackConstraints();
}

JSMediaTrackConstraints::~JSMediaTrackConstraints()
{
    releaseImplIfNotNull();
}

bool JSMediaTrackConstraints::getOwnPropertySlot(JSObject* object, ExecState* exec, PropertyName propertyName, PropertySlot& slot)
{
    JSMediaTrackConstraints* thisObject = jsCast<JSMediaTrackConstraints*>(object);
    ASSERT_GC_OBJECT_INHERITS(thisObject, info());
    return getStaticValueSlot<JSMediaTrackConstraints, Base>(exec, JSMediaTrackConstraintsTable, thisObject, propertyName, slot);
}

EncodedJSValue jsMediaTrackConstraintsMandatory(ExecState* exec, EncodedJSValue slotBase, EncodedJSValue thisValue, PropertyName)
{
    JSMediaTrackConstraints* castedThis = jsDynamicCast<JSMediaTrackConstraints*>(JSValue::decode(thisValue));
    UNUSED_PARAM(slotBase);
    if (!castedThis)
        return throwVMTypeError(exec);
    UNUSED_PARAM(exec);
    bool isNull = false;
    MediaTrackConstraints& impl = castedThis->impl();
    JSValue result = toJS(exec, castedThis->globalObject(), WTF::getPtr(impl.mandatory(isNull)));
    if (isNull)
        return JSValue::encode(jsNull());
    return JSValue::encode(result);
}


EncodedJSValue jsMediaTrackConstraintsOptional(ExecState* exec, EncodedJSValue slotBase, EncodedJSValue thisValue, PropertyName)
{
    JSMediaTrackConstraints* castedThis = jsDynamicCast<JSMediaTrackConstraints*>(JSValue::decode(thisValue));
    UNUSED_PARAM(slotBase);
    if (!castedThis)
        return throwVMTypeError(exec);
    UNUSED_PARAM(exec);
    bool isNull = false;
    MediaTrackConstraints& impl = castedThis->impl();
    JSValue result = jsArray(exec, castedThis->globalObject(), impl.optional(isNull));
    if (isNull)
        return JSValue::encode(jsNull());
    return JSValue::encode(result);
}


bool JSMediaTrackConstraintsOwner::isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown> handle, void*, SlotVisitor& visitor)
{
    UNUSED_PARAM(handle);
    UNUSED_PARAM(visitor);
    return false;
}

void JSMediaTrackConstraintsOwner::finalize(JSC::Handle<JSC::Unknown> handle, void* context)
{
    JSMediaTrackConstraints* jsMediaTrackConstraints = jsCast<JSMediaTrackConstraints*>(handle.get().asCell());
    DOMWrapperWorld& world = *static_cast<DOMWrapperWorld*>(context);
    uncacheWrapper(world, &jsMediaTrackConstraints->impl(), jsMediaTrackConstraints);
    jsMediaTrackConstraints->releaseImpl();
}

#if ENABLE(BINDING_INTEGRITY)
#if PLATFORM(WIN)
#pragma warning(disable: 4483)
extern "C" { extern void (*const __identifier("??_7MediaTrackConstraints@WebCore@@6B@")[])(); }
#else
extern "C" { extern void* _ZTVN7WebCore21MediaTrackConstraintsE[]; }
#endif
#endif
JSC::JSValue toJS(JSC::ExecState* exec, JSDOMGlobalObject* globalObject, MediaTrackConstraints* impl)
{
    if (!impl)
        return jsNull();
    if (JSValue result = getExistingWrapper<JSMediaTrackConstraints>(exec, impl))
        return result;

#if ENABLE(BINDING_INTEGRITY)
    void* actualVTablePointer = *(reinterpret_cast<void**>(impl));
#if PLATFORM(WIN)
    void* expectedVTablePointer = reinterpret_cast<void*>(__identifier("??_7MediaTrackConstraints@WebCore@@6B@"));
#else
    void* expectedVTablePointer = &_ZTVN7WebCore21MediaTrackConstraintsE[2];
#if COMPILER(CLANG)
    // If this fails MediaTrackConstraints does not have a vtable, so you need to add the
    // ImplementationLacksVTable attribute to the interface definition
    COMPILE_ASSERT(__is_polymorphic(MediaTrackConstraints), MediaTrackConstraints_is_not_polymorphic);
#endif
#endif
    // If you hit this assertion you either have a use after free bug, or
    // MediaTrackConstraints has subclasses. If MediaTrackConstraints has subclasses that get passed
    // to toJS() we currently require MediaTrackConstraints you to opt out of binding hardening
    // by adding the SkipVTableValidation attribute to the interface IDL definition
    RELEASE_ASSERT(actualVTablePointer == expectedVTablePointer);
#endif
    ReportMemoryCost<MediaTrackConstraints>::reportMemoryCost(exec, impl);
    return createNewWrapper<JSMediaTrackConstraints>(exec, globalObject, impl);
}

MediaTrackConstraints* toMediaTrackConstraints(JSC::JSValue value)
{
    return value.inherits(JSMediaTrackConstraints::info()) ? &jsCast<JSMediaTrackConstraints*>(value)->impl() : 0;
}

}

#endif // ENABLE(MEDIA_STREAM)
