/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"

#if ENABLE(PERFORMANCE_TIMELINE)

#include "JSPerformanceEntry.h"

#include "PerformanceEntry.h"
#include "URL.h"
#include <runtime/JSString.h>
#include <wtf/GetPtr.h>

using namespace JSC;

namespace WebCore {

/* Hash table */

static const HashTableValue JSPerformanceEntryTableValues[] =
{
    { "name", DontDelete | ReadOnly, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsPerformanceEntryName), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
    { "entryType", DontDelete | ReadOnly, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsPerformanceEntryEntryType), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
    { "startTime", DontDelete | ReadOnly, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsPerformanceEntryStartTime), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
    { "duration", DontDelete | ReadOnly, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsPerformanceEntryDuration), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
    { "constructor", DontEnum | ReadOnly, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsPerformanceEntryConstructor), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
    { 0, 0, NoIntrinsic, 0, 0 }
};

static const HashTable JSPerformanceEntryTable = { 17, 15, true, JSPerformanceEntryTableValues, 0 };
/* Hash table for constructor */

static const HashTableValue JSPerformanceEntryConstructorTableValues[] =
{
    { 0, 0, NoIntrinsic, 0, 0 }
};

static const HashTable JSPerformanceEntryConstructorTable = { 1, 0, false, JSPerformanceEntryConstructorTableValues, 0 };
const ClassInfo JSPerformanceEntryConstructor::s_info = { "PerformanceEntryConstructor", &Base::s_info, &JSPerformanceEntryConstructorTable, 0, CREATE_METHOD_TABLE(JSPerformanceEntryConstructor) };

JSPerformanceEntryConstructor::JSPerformanceEntryConstructor(Structure* structure, JSDOMGlobalObject* globalObject)
    : DOMConstructorObject(structure, globalObject)
{
}

void JSPerformanceEntryConstructor::finishCreation(VM& vm, JSDOMGlobalObject* globalObject)
{
    Base::finishCreation(vm);
    ASSERT(inherits(info()));
    putDirect(vm, vm.propertyNames->prototype, JSPerformanceEntryPrototype::self(vm, globalObject), DontDelete | ReadOnly);
    putDirect(vm, vm.propertyNames->length, jsNumber(0), ReadOnly | DontDelete | DontEnum);
}

bool JSPerformanceEntryConstructor::getOwnPropertySlot(JSObject* object, ExecState* exec, PropertyName propertyName, PropertySlot& slot)
{
    return getStaticValueSlot<JSPerformanceEntryConstructor, JSDOMWrapper>(exec, JSPerformanceEntryConstructorTable, jsCast<JSPerformanceEntryConstructor*>(object), propertyName, slot);
}

/* Hash table for prototype */

static const HashTableValue JSPerformanceEntryPrototypeTableValues[] =
{
    { 0, 0, NoIntrinsic, 0, 0 }
};

static const HashTable JSPerformanceEntryPrototypeTable = { 1, 0, false, JSPerformanceEntryPrototypeTableValues, 0 };
const ClassInfo JSPerformanceEntryPrototype::s_info = { "PerformanceEntryPrototype", &Base::s_info, &JSPerformanceEntryPrototypeTable, 0, CREATE_METHOD_TABLE(JSPerformanceEntryPrototype) };

JSObject* JSPerformanceEntryPrototype::self(VM& vm, JSGlobalObject* globalObject)
{
    return getDOMPrototype<JSPerformanceEntry>(vm, globalObject);
}

const ClassInfo JSPerformanceEntry::s_info = { "PerformanceEntry", &Base::s_info, &JSPerformanceEntryTable, 0 , CREATE_METHOD_TABLE(JSPerformanceEntry) };

JSPerformanceEntry::JSPerformanceEntry(Structure* structure, JSDOMGlobalObject* globalObject, PassRefPtr<PerformanceEntry> impl)
    : JSDOMWrapper(structure, globalObject)
    , m_impl(impl.leakRef())
{
}

void JSPerformanceEntry::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    ASSERT(inherits(info()));
}

JSObject* JSPerformanceEntry::createPrototype(VM& vm, JSGlobalObject* globalObject)
{
    return JSPerformanceEntryPrototype::create(vm, globalObject, JSPerformanceEntryPrototype::createStructure(vm, globalObject, globalObject->objectPrototype()));
}

void JSPerformanceEntry::destroy(JSC::JSCell* cell)
{
    JSPerformanceEntry* thisObject = static_cast<JSPerformanceEntry*>(cell);
    thisObject->JSPerformanceEntry::~JSPerformanceEntry();
}

JSPerformanceEntry::~JSPerformanceEntry()
{
    releaseImplIfNotNull();
}

bool JSPerformanceEntry::getOwnPropertySlot(JSObject* object, ExecState* exec, PropertyName propertyName, PropertySlot& slot)
{
    JSPerformanceEntry* thisObject = jsCast<JSPerformanceEntry*>(object);
    ASSERT_GC_OBJECT_INHERITS(thisObject, info());
    return getStaticValueSlot<JSPerformanceEntry, Base>(exec, JSPerformanceEntryTable, thisObject, propertyName, slot);
}

EncodedJSValue jsPerformanceEntryName(ExecState* exec, EncodedJSValue slotBase, EncodedJSValue thisValue, PropertyName)
{
    JSPerformanceEntry* castedThis = jsDynamicCast<JSPerformanceEntry*>(JSValue::decode(thisValue));
    UNUSED_PARAM(slotBase);
    if (!castedThis)
        return throwVMTypeError(exec);
    UNUSED_PARAM(exec);
    PerformanceEntry& impl = castedThis->impl();
    JSValue result = jsStringWithCache(exec, impl.name());
    return JSValue::encode(result);
}


EncodedJSValue jsPerformanceEntryEntryType(ExecState* exec, EncodedJSValue slotBase, EncodedJSValue thisValue, PropertyName)
{
    JSPerformanceEntry* castedThis = jsDynamicCast<JSPerformanceEntry*>(JSValue::decode(thisValue));
    UNUSED_PARAM(slotBase);
    if (!castedThis)
        return throwVMTypeError(exec);
    UNUSED_PARAM(exec);
    PerformanceEntry& impl = castedThis->impl();
    JSValue result = jsStringWithCache(exec, impl.entryType());
    return JSValue::encode(result);
}


EncodedJSValue jsPerformanceEntryStartTime(ExecState* exec, EncodedJSValue slotBase, EncodedJSValue thisValue, PropertyName)
{
    JSPerformanceEntry* castedThis = jsDynamicCast<JSPerformanceEntry*>(JSValue::decode(thisValue));
    UNUSED_PARAM(slotBase);
    if (!castedThis)
        return throwVMTypeError(exec);
    UNUSED_PARAM(exec);
    PerformanceEntry& impl = castedThis->impl();
    JSValue result = jsNumber(impl.startTime());
    return JSValue::encode(result);
}


EncodedJSValue jsPerformanceEntryDuration(ExecState* exec, EncodedJSValue slotBase, EncodedJSValue thisValue, PropertyName)
{
    JSPerformanceEntry* castedThis = jsDynamicCast<JSPerformanceEntry*>(JSValue::decode(thisValue));
    UNUSED_PARAM(slotBase);
    if (!castedThis)
        return throwVMTypeError(exec);
    UNUSED_PARAM(exec);
    PerformanceEntry& impl = castedThis->impl();
    JSValue result = jsNumber(impl.duration());
    return JSValue::encode(result);
}


EncodedJSValue jsPerformanceEntryConstructor(ExecState* exec, EncodedJSValue thisValue, EncodedJSValue, PropertyName)
{
    JSPerformanceEntry* domObject = jsDynamicCast<JSPerformanceEntry*>(JSValue::decode(thisValue));
    if (!domObject)
        return throwVMTypeError(exec);
    if (!domObject)
        return throwVMTypeError(exec);
    return JSValue::encode(JSPerformanceEntry::getConstructor(exec->vm(), domObject->globalObject()));
}

JSValue JSPerformanceEntry::getConstructor(VM& vm, JSGlobalObject* globalObject)
{
    return getDOMConstructor<JSPerformanceEntryConstructor>(vm, jsCast<JSDOMGlobalObject*>(globalObject));
}

bool JSPerformanceEntryOwner::isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown> handle, void*, SlotVisitor& visitor)
{
    UNUSED_PARAM(handle);
    UNUSED_PARAM(visitor);
    return false;
}

void JSPerformanceEntryOwner::finalize(JSC::Handle<JSC::Unknown> handle, void* context)
{
    JSPerformanceEntry* jsPerformanceEntry = jsCast<JSPerformanceEntry*>(handle.get().asCell());
    DOMWrapperWorld& world = *static_cast<DOMWrapperWorld*>(context);
    uncacheWrapper(world, &jsPerformanceEntry->impl(), jsPerformanceEntry);
    jsPerformanceEntry->releaseImpl();
}

PerformanceEntry* toPerformanceEntry(JSC::JSValue value)
{
    return value.inherits(JSPerformanceEntry::info()) ? &jsCast<JSPerformanceEntry*>(value)->impl() : 0;
}

}

#endif // ENABLE(PERFORMANCE_TIMELINE)
