/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"

#if ENABLE(USER_TIMING)

#include "JSPerformanceMark.h"

#include "PerformanceMark.h"
#include <wtf/GetPtr.h>

using namespace JSC;

namespace WebCore {

/* Hash table */

static const HashTableValue JSPerformanceMarkTableValues[] =
{
    { "constructor", DontEnum | ReadOnly, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsPerformanceMarkConstructor), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
    { 0, 0, NoIntrinsic, 0, 0 }
};

static const HashTable JSPerformanceMarkTable = { 2, 1, true, JSPerformanceMarkTableValues, 0 };
/* Hash table for constructor */

static const HashTableValue JSPerformanceMarkConstructorTableValues[] =
{
    { 0, 0, NoIntrinsic, 0, 0 }
};

static const HashTable JSPerformanceMarkConstructorTable = { 1, 0, false, JSPerformanceMarkConstructorTableValues, 0 };
const ClassInfo JSPerformanceMarkConstructor::s_info = { "PerformanceMarkConstructor", &Base::s_info, &JSPerformanceMarkConstructorTable, 0, CREATE_METHOD_TABLE(JSPerformanceMarkConstructor) };

JSPerformanceMarkConstructor::JSPerformanceMarkConstructor(Structure* structure, JSDOMGlobalObject* globalObject)
    : DOMConstructorObject(structure, globalObject)
{
}

void JSPerformanceMarkConstructor::finishCreation(VM& vm, JSDOMGlobalObject* globalObject)
{
    Base::finishCreation(vm);
    ASSERT(inherits(info()));
    putDirect(vm, vm.propertyNames->prototype, JSPerformanceMarkPrototype::self(vm, globalObject), DontDelete | ReadOnly);
    putDirect(vm, vm.propertyNames->length, jsNumber(0), ReadOnly | DontDelete | DontEnum);
}

bool JSPerformanceMarkConstructor::getOwnPropertySlot(JSObject* object, ExecState* exec, PropertyName propertyName, PropertySlot& slot)
{
    return getStaticValueSlot<JSPerformanceMarkConstructor, JSDOMWrapper>(exec, JSPerformanceMarkConstructorTable, jsCast<JSPerformanceMarkConstructor*>(object), propertyName, slot);
}

/* Hash table for prototype */

static const HashTableValue JSPerformanceMarkPrototypeTableValues[] =
{
    { 0, 0, NoIntrinsic, 0, 0 }
};

static const HashTable JSPerformanceMarkPrototypeTable = { 1, 0, false, JSPerformanceMarkPrototypeTableValues, 0 };
const ClassInfo JSPerformanceMarkPrototype::s_info = { "PerformanceMarkPrototype", &Base::s_info, &JSPerformanceMarkPrototypeTable, 0, CREATE_METHOD_TABLE(JSPerformanceMarkPrototype) };

JSObject* JSPerformanceMarkPrototype::self(VM& vm, JSGlobalObject* globalObject)
{
    return getDOMPrototype<JSPerformanceMark>(vm, globalObject);
}

const ClassInfo JSPerformanceMark::s_info = { "PerformanceMark", &Base::s_info, &JSPerformanceMarkTable, 0 , CREATE_METHOD_TABLE(JSPerformanceMark) };

JSPerformanceMark::JSPerformanceMark(Structure* structure, JSDOMGlobalObject* globalObject, PassRefPtr<PerformanceMark> impl)
    : JSPerformanceEntry(structure, globalObject, impl)
{
}

void JSPerformanceMark::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    ASSERT(inherits(info()));
}

JSObject* JSPerformanceMark::createPrototype(VM& vm, JSGlobalObject* globalObject)
{
    return JSPerformanceMarkPrototype::create(vm, globalObject, JSPerformanceMarkPrototype::createStructure(vm, globalObject, JSPerformanceEntryPrototype::self(vm, globalObject)));
}

bool JSPerformanceMark::getOwnPropertySlot(JSObject* object, ExecState* exec, PropertyName propertyName, PropertySlot& slot)
{
    JSPerformanceMark* thisObject = jsCast<JSPerformanceMark*>(object);
    ASSERT_GC_OBJECT_INHERITS(thisObject, info());
    return getStaticValueSlot<JSPerformanceMark, Base>(exec, JSPerformanceMarkTable, thisObject, propertyName, slot);
}

EncodedJSValue jsPerformanceMarkConstructor(ExecState* exec, EncodedJSValue thisValue, EncodedJSValue, PropertyName)
{
    JSPerformanceMark* domObject = jsDynamicCast<JSPerformanceMark*>(JSValue::decode(thisValue));
    if (!domObject)
        return throwVMTypeError(exec);
    if (!domObject)
        return throwVMTypeError(exec);
    return JSValue::encode(JSPerformanceMark::getConstructor(exec->vm(), domObject->globalObject()));
}

JSValue JSPerformanceMark::getConstructor(VM& vm, JSGlobalObject* globalObject)
{
    return getDOMConstructor<JSPerformanceMarkConstructor>(vm, jsCast<JSDOMGlobalObject*>(globalObject));
}


}

#endif // ENABLE(USER_TIMING)
