/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"

#if ENABLE(MEDIA_STREAM)

#include "JSRTCDataChannelEvent.h"

#include "JSRTCDataChannel.h"
#include "RTCDataChannel.h"
#include "RTCDataChannelEvent.h"
#include <wtf/GetPtr.h>

using namespace JSC;

namespace WebCore {

/* Hash table */

static const HashTableValue JSRTCDataChannelEventTableValues[] =
{
    { "channel", DontDelete | ReadOnly, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsRTCDataChannelEventChannel), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
    { 0, 0, NoIntrinsic, 0, 0 }
};

static const HashTable JSRTCDataChannelEventTable = { 2, 1, true, JSRTCDataChannelEventTableValues, 0 };
/* Hash table for prototype */

static const HashTableValue JSRTCDataChannelEventPrototypeTableValues[] =
{
    { 0, 0, NoIntrinsic, 0, 0 }
};

static const HashTable JSRTCDataChannelEventPrototypeTable = { 1, 0, false, JSRTCDataChannelEventPrototypeTableValues, 0 };
const ClassInfo JSRTCDataChannelEventPrototype::s_info = { "RTCDataChannelEventPrototype", &Base::s_info, &JSRTCDataChannelEventPrototypeTable, 0, CREATE_METHOD_TABLE(JSRTCDataChannelEventPrototype) };

JSObject* JSRTCDataChannelEventPrototype::self(VM& vm, JSGlobalObject* globalObject)
{
    return getDOMPrototype<JSRTCDataChannelEvent>(vm, globalObject);
}

const ClassInfo JSRTCDataChannelEvent::s_info = { "RTCDataChannelEvent", &Base::s_info, &JSRTCDataChannelEventTable, 0 , CREATE_METHOD_TABLE(JSRTCDataChannelEvent) };

JSRTCDataChannelEvent::JSRTCDataChannelEvent(Structure* structure, JSDOMGlobalObject* globalObject, PassRefPtr<RTCDataChannelEvent> impl)
    : JSEvent(structure, globalObject, impl)
{
}

void JSRTCDataChannelEvent::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    ASSERT(inherits(info()));
}

JSObject* JSRTCDataChannelEvent::createPrototype(VM& vm, JSGlobalObject* globalObject)
{
    return JSRTCDataChannelEventPrototype::create(vm, globalObject, JSRTCDataChannelEventPrototype::createStructure(vm, globalObject, JSEventPrototype::self(vm, globalObject)));
}

bool JSRTCDataChannelEvent::getOwnPropertySlot(JSObject* object, ExecState* exec, PropertyName propertyName, PropertySlot& slot)
{
    JSRTCDataChannelEvent* thisObject = jsCast<JSRTCDataChannelEvent*>(object);
    ASSERT_GC_OBJECT_INHERITS(thisObject, info());
    return getStaticValueSlot<JSRTCDataChannelEvent, Base>(exec, JSRTCDataChannelEventTable, thisObject, propertyName, slot);
}

EncodedJSValue jsRTCDataChannelEventChannel(ExecState* exec, EncodedJSValue slotBase, EncodedJSValue thisValue, PropertyName)
{
    JSRTCDataChannelEvent* castedThis = jsDynamicCast<JSRTCDataChannelEvent*>(JSValue::decode(thisValue));
    UNUSED_PARAM(slotBase);
    if (!castedThis)
        return throwVMTypeError(exec);
    UNUSED_PARAM(exec);
    RTCDataChannelEvent& impl = castedThis->impl();
    JSValue result = toJS(exec, castedThis->globalObject(), WTF::getPtr(impl.channel()));
    return JSValue::encode(result);
}



}

#endif // ENABLE(MEDIA_STREAM)
