/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"

#if ENABLE(INPUT_SPEECH)

#include "JSSpeechInputResultList.h"

#include "ExceptionCode.h"
#include "JSDOMBinding.h"
#include "JSSpeechInputResult.h"
#include "SpeechInputResult.h"
#include "SpeechInputResultList.h"
#include <runtime/Error.h>
#include <runtime/PropertyNameArray.h>
#include <wtf/GetPtr.h>

using namespace JSC;

namespace WebCore {

/* Hash table */

static const HashTableValue JSSpeechInputResultListTableValues[] =
{
    { "length", DontDelete | ReadOnly, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsSpeechInputResultListLength), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
    { 0, 0, NoIntrinsic, 0, 0 }
};

static const HashTable JSSpeechInputResultListTable = { 2, 1, true, JSSpeechInputResultListTableValues, 0 };
/* Hash table for prototype */

static const HashTableValue JSSpeechInputResultListPrototypeTableValues[] =
{
    { "item", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsSpeechInputResultListPrototypeFunctionItem), (intptr_t) (1) },
    { 0, 0, NoIntrinsic, 0, 0 }
};

static const HashTable JSSpeechInputResultListPrototypeTable = { 2, 1, false, JSSpeechInputResultListPrototypeTableValues, 0 };
const ClassInfo JSSpeechInputResultListPrototype::s_info = { "SpeechInputResultListPrototype", &Base::s_info, &JSSpeechInputResultListPrototypeTable, 0, CREATE_METHOD_TABLE(JSSpeechInputResultListPrototype) };

JSObject* JSSpeechInputResultListPrototype::self(VM& vm, JSGlobalObject* globalObject)
{
    return getDOMPrototype<JSSpeechInputResultList>(vm, globalObject);
}

bool JSSpeechInputResultListPrototype::getOwnPropertySlot(JSObject* object, ExecState* exec, PropertyName propertyName, PropertySlot& slot)
{
    JSSpeechInputResultListPrototype* thisObject = jsCast<JSSpeechInputResultListPrototype*>(object);
    return getStaticFunctionSlot<JSObject>(exec, JSSpeechInputResultListPrototypeTable, thisObject, propertyName, slot);
}

const ClassInfo JSSpeechInputResultList::s_info = { "SpeechInputResultList", &Base::s_info, &JSSpeechInputResultListTable, 0 , CREATE_METHOD_TABLE(JSSpeechInputResultList) };

JSSpeechInputResultList::JSSpeechInputResultList(Structure* structure, JSDOMGlobalObject* globalObject, PassRefPtr<SpeechInputResultList> impl)
    : JSDOMWrapper(structure, globalObject)
    , m_impl(impl.leakRef())
{
}

void JSSpeechInputResultList::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    ASSERT(inherits(info()));
}

JSObject* JSSpeechInputResultList::createPrototype(VM& vm, JSGlobalObject* globalObject)
{
    return JSSpeechInputResultListPrototype::create(vm, globalObject, JSSpeechInputResultListPrototype::createStructure(vm, globalObject, globalObject->objectPrototype()));
}

void JSSpeechInputResultList::destroy(JSC::JSCell* cell)
{
    JSSpeechInputResultList* thisObject = static_cast<JSSpeechInputResultList*>(cell);
    thisObject->JSSpeechInputResultList::~JSSpeechInputResultList();
}

JSSpeechInputResultList::~JSSpeechInputResultList()
{
    releaseImplIfNotNull();
}

bool JSSpeechInputResultList::getOwnPropertySlot(JSObject* object, ExecState* exec, PropertyName propertyName, PropertySlot& slot)
{
    JSSpeechInputResultList* thisObject = jsCast<JSSpeechInputResultList*>(object);
    ASSERT_GC_OBJECT_INHERITS(thisObject, info());
    const HashEntry* entry = getStaticValueSlotEntryWithoutCaching<JSSpeechInputResultList>(exec, propertyName);
    if (entry) {
        slot.setCustom(thisObject, entry->attributes(), entry->propertyGetter());
        return true;
    }
    unsigned index = propertyName.asIndex();
    if (index != PropertyName::NotAnIndex && index < thisObject->impl().length()) {
        unsigned attributes = DontDelete | ReadOnly;
        slot.setCustomIndex(thisObject, attributes, index, indexGetter);
        return true;
    }
    return getStaticValueSlot<JSSpeechInputResultList, Base>(exec, JSSpeechInputResultListTable, thisObject, propertyName, slot);
}

bool JSSpeechInputResultList::getOwnPropertySlotByIndex(JSObject* object, ExecState* exec, unsigned index, PropertySlot& slot)
{
    JSSpeechInputResultList* thisObject = jsCast<JSSpeechInputResultList*>(object);
    ASSERT_GC_OBJECT_INHERITS(thisObject, info());
    if (index < thisObject->impl().length()) {
        unsigned attributes = DontDelete | ReadOnly;
        slot.setCustomIndex(thisObject, attributes, index, thisObject->indexGetter);
        return true;
    }
    return Base::getOwnPropertySlotByIndex(thisObject, exec, index, slot);
}

EncodedJSValue jsSpeechInputResultListLength(ExecState* exec, EncodedJSValue slotBase, EncodedJSValue thisValue, PropertyName)
{
    JSSpeechInputResultList* castedThis = jsDynamicCast<JSSpeechInputResultList*>(JSValue::decode(thisValue));
    UNUSED_PARAM(slotBase);
    if (!castedThis)
        return throwVMTypeError(exec);
    UNUSED_PARAM(exec);
    SpeechInputResultList& impl = castedThis->impl();
    JSValue result = jsNumber(impl.length());
    return JSValue::encode(result);
}


void JSSpeechInputResultList::getOwnPropertyNames(JSObject* object, ExecState* exec, PropertyNameArray& propertyNames, EnumerationMode mode)
{
    JSSpeechInputResultList* thisObject = jsCast<JSSpeechInputResultList*>(object);
    ASSERT_GC_OBJECT_INHERITS(thisObject, info());
    for (unsigned i = 0, count = thisObject->impl().length(); i < count; ++i)
        propertyNames.add(Identifier::from(exec, i));
     Base::getOwnPropertyNames(thisObject, exec, propertyNames, mode);
}

EncodedJSValue JSC_HOST_CALL jsSpeechInputResultListPrototypeFunctionItem(ExecState* exec)
{
    JSValue thisValue = exec->hostThisValue();
    JSSpeechInputResultList* castedThis = jsDynamicCast<JSSpeechInputResultList*>(thisValue);
    if (!castedThis)
        return throwVMTypeError(exec);
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSSpeechInputResultList::info());
    SpeechInputResultList& impl = castedThis->impl();
    if (exec->argumentCount() < 1)
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    int index(toUInt32(exec, exec->argument(0), NormalConversion));
    if (index < 0) {
        setDOMException(exec, INDEX_SIZE_ERR);
        return JSValue::encode(jsUndefined());
    }
    if (exec->hadException())
        return JSValue::encode(jsUndefined());

    JSC::JSValue result = toJS(exec, castedThis->globalObject(), WTF::getPtr(impl.item(index)));
    return JSValue::encode(result);
}


EncodedJSValue JSSpeechInputResultList::indexGetter(ExecState* exec, EncodedJSValue slotBase, EncodedJSValue, unsigned index)
{
    JSSpeechInputResultList* thisObj = jsCast<JSSpeechInputResultList*>(JSValue::decode(slotBase));
    ASSERT_GC_OBJECT_INHERITS(thisObj, info());
    return JSValue::encode(toJS(exec, thisObj->globalObject(), thisObj->impl().item(index)));
}

bool JSSpeechInputResultListOwner::isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown> handle, void*, SlotVisitor& visitor)
{
    UNUSED_PARAM(handle);
    UNUSED_PARAM(visitor);
    return false;
}

void JSSpeechInputResultListOwner::finalize(JSC::Handle<JSC::Unknown> handle, void* context)
{
    JSSpeechInputResultList* jsSpeechInputResultList = jsCast<JSSpeechInputResultList*>(handle.get().asCell());
    DOMWrapperWorld& world = *static_cast<DOMWrapperWorld*>(context);
    uncacheWrapper(world, &jsSpeechInputResultList->impl(), jsSpeechInputResultList);
    jsSpeechInputResultList->releaseImpl();
}

JSC::JSValue toJS(JSC::ExecState* exec, JSDOMGlobalObject* globalObject, SpeechInputResultList* impl)
{
    if (!impl)
        return jsNull();
    if (JSValue result = getExistingWrapper<JSSpeechInputResultList>(exec, impl))
        return result;
#if COMPILER(CLANG)
    // If you hit this failure the interface definition has the ImplementationLacksVTable
    // attribute. You should remove that attribute. If the class has subclasses
    // that may be passed through this toJS() function you should use the SkipVTableValidation
    // attribute to SpeechInputResultList.
    COMPILE_ASSERT(!__is_polymorphic(SpeechInputResultList), SpeechInputResultList_is_polymorphic_but_idl_claims_not_to_be);
#endif
    ReportMemoryCost<SpeechInputResultList>::reportMemoryCost(exec, impl);
    return createNewWrapper<JSSpeechInputResultList>(exec, globalObject, impl);
}

SpeechInputResultList* toSpeechInputResultList(JSC::JSValue value)
{
    return value.inherits(JSSpeechInputResultList::info()) ? &jsCast<JSSpeechInputResultList*>(value)->impl() : 0;
}

}

#endif // ENABLE(INPUT_SPEECH)
