/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"

#if ENABLE(QUOTA)

#include "JSStorageQuota.h"

#include "ExceptionCode.h"
#include "JSDOMBinding.h"
#include "JSStorageErrorCallback.h"
#include "JSStorageQuotaCallback.h"
#include "JSStorageUsageCallback.h"
#include "StorageQuota.h"
#include <runtime/Error.h>
#include <wtf/GetPtr.h>

using namespace JSC;

namespace WebCore {

/* Hash table for prototype */

static const HashTableValue JSStorageQuotaPrototypeTableValues[] =
{
    { "queryUsageAndQuota", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsStorageQuotaPrototypeFunctionQueryUsageAndQuota), (intptr_t) (1) },
    { "requestQuota", JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsStorageQuotaPrototypeFunctionRequestQuota), (intptr_t) (1) },
    { 0, 0, NoIntrinsic, 0, 0 }
};

static const HashTable JSStorageQuotaPrototypeTable = { 5, 3, false, JSStorageQuotaPrototypeTableValues, 0 };
const ClassInfo JSStorageQuotaPrototype::s_info = { "StorageQuotaPrototype", &Base::s_info, &JSStorageQuotaPrototypeTable, 0, CREATE_METHOD_TABLE(JSStorageQuotaPrototype) };

JSObject* JSStorageQuotaPrototype::self(VM& vm, JSGlobalObject* globalObject)
{
    return getDOMPrototype<JSStorageQuota>(vm, globalObject);
}

bool JSStorageQuotaPrototype::getOwnPropertySlot(JSObject* object, ExecState* exec, PropertyName propertyName, PropertySlot& slot)
{
    JSStorageQuotaPrototype* thisObject = jsCast<JSStorageQuotaPrototype*>(object);
    return getStaticFunctionSlot<JSObject>(exec, JSStorageQuotaPrototypeTable, thisObject, propertyName, slot);
}

const ClassInfo JSStorageQuota::s_info = { "StorageQuota", &Base::s_info, 0, 0 , CREATE_METHOD_TABLE(JSStorageQuota) };

JSStorageQuota::JSStorageQuota(Structure* structure, JSDOMGlobalObject* globalObject, PassRefPtr<StorageQuota> impl)
    : JSDOMWrapper(structure, globalObject)
    , m_impl(impl.leakRef())
{
}

void JSStorageQuota::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    ASSERT(inherits(info()));
}

JSObject* JSStorageQuota::createPrototype(VM& vm, JSGlobalObject* globalObject)
{
    return JSStorageQuotaPrototype::create(vm, globalObject, JSStorageQuotaPrototype::createStructure(vm, globalObject, globalObject->objectPrototype()));
}

void JSStorageQuota::destroy(JSC::JSCell* cell)
{
    JSStorageQuota* thisObject = static_cast<JSStorageQuota*>(cell);
    thisObject->JSStorageQuota::~JSStorageQuota();
}

JSStorageQuota::~JSStorageQuota()
{
    releaseImplIfNotNull();
}

EncodedJSValue JSC_HOST_CALL jsStorageQuotaPrototypeFunctionQueryUsageAndQuota(ExecState* exec)
{
    JSValue thisValue = exec->hostThisValue();
    JSStorageQuota* castedThis = jsDynamicCast<JSStorageQuota*>(thisValue);
    if (!castedThis)
        return throwVMTypeError(exec);
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSStorageQuota::info());
    StorageQuota& impl = castedThis->impl();
    if (exec->argumentCount() < 1)
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    ScriptExecutionContext* scriptContext = jsCast<JSDOMGlobalObject*>(exec->lexicalGlobalObject())->scriptExecutionContext();
    if (!scriptContext)
        return JSValue::encode(jsUndefined());
    if (!exec->argument(0).isFunction())
        return throwVMTypeError(exec);
    RefPtr<StorageUsageCallback> usageCallback = JSStorageUsageCallback::create(asObject(exec->uncheckedArgument(0)), castedThis->globalObject());
    RefPtr<StorageErrorCallback> errorCallback;
    if (!exec->argument(1).isUndefinedOrNull()) {
        if (!exec->uncheckedArgument(1).isFunction())
            return throwVMTypeError(exec);
        errorCallback = JSStorageErrorCallback::create(asObject(exec->uncheckedArgument(1)), castedThis->globalObject());
    }
    impl.queryUsageAndQuota(scriptContext, usageCallback, errorCallback);
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsStorageQuotaPrototypeFunctionRequestQuota(ExecState* exec)
{
    JSValue thisValue = exec->hostThisValue();
    JSStorageQuota* castedThis = jsDynamicCast<JSStorageQuota*>(thisValue);
    if (!castedThis)
        return throwVMTypeError(exec);
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSStorageQuota::info());
    StorageQuota& impl = castedThis->impl();
    if (exec->argumentCount() < 1)
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    ScriptExecutionContext* scriptContext = jsCast<JSDOMGlobalObject*>(exec->lexicalGlobalObject())->scriptExecutionContext();
    if (!scriptContext)
        return JSValue::encode(jsUndefined());
    unsigned long long newQuotaInBytes(toUInt64(exec, exec->argument(0), NormalConversion));
    if (exec->hadException())
        return JSValue::encode(jsUndefined());
    RefPtr<StorageQuotaCallback> quotaCallback;
    if (!exec->argument(1).isUndefinedOrNull()) {
        if (!exec->uncheckedArgument(1).isFunction())
            return throwVMTypeError(exec);
        quotaCallback = JSStorageQuotaCallback::create(asObject(exec->uncheckedArgument(1)), castedThis->globalObject());
    }
    RefPtr<StorageErrorCallback> errorCallback;
    if (!exec->argument(2).isUndefinedOrNull()) {
        if (!exec->uncheckedArgument(2).isFunction())
            return throwVMTypeError(exec);
        errorCallback = JSStorageErrorCallback::create(asObject(exec->uncheckedArgument(2)), castedThis->globalObject());
    }
    impl.requestQuota(scriptContext, newQuotaInBytes, quotaCallback, errorCallback);
    return JSValue::encode(jsUndefined());
}

bool JSStorageQuotaOwner::isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown> handle, void*, SlotVisitor& visitor)
{
    UNUSED_PARAM(handle);
    UNUSED_PARAM(visitor);
    return false;
}

void JSStorageQuotaOwner::finalize(JSC::Handle<JSC::Unknown> handle, void* context)
{
    JSStorageQuota* jsStorageQuota = jsCast<JSStorageQuota*>(handle.get().asCell());
    DOMWrapperWorld& world = *static_cast<DOMWrapperWorld*>(context);
    uncacheWrapper(world, &jsStorageQuota->impl(), jsStorageQuota);
    jsStorageQuota->releaseImpl();
}

JSC::JSValue toJS(JSC::ExecState* exec, JSDOMGlobalObject* globalObject, StorageQuota* impl)
{
    if (!impl)
        return jsNull();
    if (JSValue result = getExistingWrapper<JSStorageQuota>(exec, impl))
        return result;
#if COMPILER(CLANG)
    // If you hit this failure the interface definition has the ImplementationLacksVTable
    // attribute. You should remove that attribute. If the class has subclasses
    // that may be passed through this toJS() function you should use the SkipVTableValidation
    // attribute to StorageQuota.
    COMPILE_ASSERT(!__is_polymorphic(StorageQuota), StorageQuota_is_polymorphic_but_idl_claims_not_to_be);
#endif
    ReportMemoryCost<StorageQuota>::reportMemoryCost(exec, impl);
    return createNewWrapper<JSStorageQuota>(exec, globalObject, impl);
}

StorageQuota* toStorageQuota(JSC::JSValue value)
{
    return value.inherits(JSStorageQuota::info()) ? &jsCast<JSStorageQuota*>(value)->impl() : 0;
}

}

#endif // ENABLE(QUOTA)
